Index: main/channel.c
===================================================================
--- main/channel.c	(revision 41767)
+++ main/channel.c	(working copy)
@@ -1848,6 +1848,7 @@
 
 			switch(f->frametype) {
 			case AST_FRAME_DTMF:
+			case AST_FRAME_DTMF_BEGIN:
 				res = f->subclass;
 				ast_frfree(f);
 				return res;
@@ -2034,10 +2035,11 @@
 			if (ast_test_flag(chan, AST_FLAG_DEFER_DTMF | AST_FLAG_EMULATE_DTMF)) {
 				if (strlen(chan->dtmfq) < sizeof(chan->dtmfq) - 2)
 					chan->dtmfq[strlen(chan->dtmfq)] = f->subclass;
-				else
+				else{
 					ast_log(LOG_WARNING, "Dropping deferred DTMF digits on %s\n", chan->name);
 				ast_frfree(f);
 				f = &ast_null_frame;
+				}
 			} else if (!ast_test_flag(chan, AST_FLAG_IN_DTMF)) {
 				f->frametype = AST_FRAME_DTMF_BEGIN;
 				ast_set_flag(chan, AST_FLAG_EMULATE_DTMF);
